--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -13068,26 +13551,543 @@
 	(void) sprintf(bp, "\n[<==END] ISP Debug Dump");
 	bp += strlen(bp);
 
-	(void) sprintf(bp, "\n\nRequest Queue");
-	bp += strlen(bp);
-	for (cnt = 0; cnt < REQUEST_QUEUE_SIZE / 4; cnt++) {
-		if (cnt % 8 == 0) {
-			(void) sprintf(bp, "\n%08x: ", cnt);
+	dp = fw->req_rsp_ext_mem + (ha->rsp_queues_cnt * 4);
+	for (cnt = 0; cnt < 2 && fw->req_q_size[cnt]; cnt++) {
+		dp2 = dp;
+		for (cnt1 = 0; cnt1 < fw->req_q_size[cnt] / 4; cnt1++) {
+			if (*dp2++) {
+				break;
+			}
+		}
+		if (cnt1 == fw->req_q_size[cnt] / 4) {
+			dp = dp2;
+			continue;
+		}
+		(void) sprintf(bp, "\n\nRequest Queue\nQueue %d:", cnt);
+		bp += strlen(bp);
+		for (cnt1 = 0; cnt1 < fw->req_q_size[cnt] / 4; cnt1++) {
+			if (cnt1 % 8 == 0) {
+				(void) sprintf(bp, "\n%08x: ", cnt1);
+				bp += strlen(bp);
+			}
+			(void) sprintf(bp, "%08x ", *dp++);
 			bp += strlen(bp);
 		}
-		(void) sprintf(bp, "%08x ", fw->req_q[cnt]);
+	}
+
+	for (cnt = 0; cnt < ha->rsp_queues_cnt && cnt < 16; cnt++) {
+		dp2 = dp;
+		for (cnt1 = 0; cnt1 < ha->rsp_queues[cnt]->rsp_ring.size / 4;
+		    cnt1++) {
+			if (*dp2++) {
+				break;
+			}
+		}
+		if (cnt1 == ha->rsp_queues[cnt]->rsp_ring.size / 4) {
+			dp = dp2;
+			continue;
+		}
+		(void) sprintf(bp, "\n\nResponse Queue\nQueue %d:", cnt);
 		bp += strlen(bp);
+		for (cnt1 = 0; cnt1 < ha->rsp_queues[cnt]->rsp_ring.size / 4;
+		    cnt1++) {
+			if (cnt1 % 8 == 0) {
+				(void) sprintf(bp, "\n%08x: ", cnt1);
+				bp += strlen(bp);
+			}
+			(void) sprintf(bp, "%08x ", *dp++);
+			bp += strlen(bp);
+		}
 	}
 
-	(void) sprintf(bp, "\n\nResponse Queue");
+	if (CFG_IST(ha, CFG_ENABLE_FWEXTTRACE) &&
+	    (ha->fwexttracebuf.bp != NULL)) {
+		uint32_t cnt_b = 0;
+		uint64_t w64 = (uintptr_t)ha->fwexttracebuf.bp;
+
+		(void) sprintf(bp, "\n\nExtended Trace Buffer Memory");
+		bp += strlen(bp);
+		/* show data address as a byte address, data as long words */
+		for (cnt = 0; cnt < FWEXTSIZE / 4; cnt++) {
+			cnt_b = cnt * 4;
+			if (cnt_b % 32 == 0) {
+				(void) sprintf(bp, "\n%08x: ",
+				    (int)(w64 + cnt_b));
+				bp += 11;
+			}
+			(void) sprintf(bp, "%08x ", fw->ext_trace_buf[cnt]);
+			bp += 9;
+		}
+	}
+
+	if (CFG_IST(ha, CFG_ENABLE_FWFCETRACE) &&
+	    (ha->fwfcetracebuf.bp != NULL)) {
+		uint32_t cnt_b = 0;
+		uint64_t w64 = (uintptr_t)ha->fwfcetracebuf.bp;
+
+		(void) sprintf(bp, "\n\nFC Event Trace Buffer Memory");
+		bp += strlen(bp);
+		/* show data address as a byte address, data as long words */
+		for (cnt = 0; cnt < FWFCESIZE / 4; cnt++) {
+			cnt_b = cnt * 4;
+			if (cnt_b % 32 == 0) {
+				(void) sprintf(bp, "\n%08x: ",
+				    (int)(w64 + cnt_b));
+				bp += 11;
+			}
+			(void) sprintf(bp, "%08x ", fw->fce_trace_buf[cnt]);
+			bp += 9;
+		}
+	}
+
+	(void) sprintf(bp, "\n\n");
 	bp += strlen(bp);
-	for (cnt = 0; cnt < RESPONSE_QUEUE_SIZE / 4; cnt++) {
+
+	cnt = (uint32_t)((uintptr_t)bp - (uintptr_t)bufp);
+
+	QL_PRINT_10(ha, "done=%xh\n", cnt);
+
+	return (cnt);
+}
+
+/*
+ * ql_81xx_ascii_fw_dump
+ *	Converts ISP81xx firmware binary dump to ascii.
+ *
+ * Input:
+ *	ha = adapter state pointer.
+ *	bptr = buffer pointer.
+ *
+ * Returns:
+ *	Amount of data buffer used.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static size_t
+ql_81xx_ascii_fw_dump(ql_adapter_state_t *ha, caddr_t bufp)
+{
+	uint32_t		cnt, cnt1, *dp, *dp2;
+	caddr_t			bp = bufp;
+	ql_81xx_fw_dump_t	*fw = ha->ql_dump_ptr;
+
+	QL_PRINT_3(ha, "started\n");
+
+	(void) sprintf(bp, "\nISP FW Version %d.%02d.%02d Attributes %X\n",
+	    ha->fw_major_version, ha->fw_minor_version,
+	    ha->fw_subminor_version, ha->fw_attributes);
+	bp += strlen(bp);
+
+	(void) sprintf(bp, "\nHCCR Register\n%08x\n", fw->hccr);
+	bp += strlen(bp);
+
+	(void) sprintf(bp, "\nR2H Status Register\n%08x\n", fw->r2h_status);
+	bp += strlen(bp);
+
+	(void) sprintf(bp, "\nAER Uncorrectable Error Status Register\n%08x\n",
+	    fw->aer_ues);
+	bp += strlen(bp);
+
+	(void) sprintf(bp, "\nHostRisc Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->hostrisc_reg) / 4; cnt++) {
 		if (cnt % 8 == 0) {
-			(void) sprintf(bp, "\n%08x: ", cnt);
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->hostrisc_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nPCIe Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->pcie_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->pcie_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) strcat(bp, "\n\nHost Interface Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->host_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->host_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bufp + strlen(bufp), "\n\nShadow Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->shadow_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->shadow_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bufp + strlen(bufp), "\n\nRISC IO Register\n%08x",
+	    fw->risc_io);
+	bp += strlen(bp);
+
+	(void) sprintf(bp, "\n\nMailbox Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->mailbox_reg) / 2; cnt++) {
+		if (cnt % 16 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%04x ", fw->mailbox_reg[cnt]);
+		bp += 5;
+	}
+
+	(void) sprintf(bp, "\n\nXSEQ GP Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xseq_gp_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xseq_gp_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXSEQ-0 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xseq_0_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xseq_0_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXSEQ-1 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xseq_1_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xseq_1_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRSEQ GP Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->rseq_gp_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->rseq_gp_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRSEQ-0 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->rseq_0_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->rseq_0_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRSEQ-1 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->rseq_1_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->rseq_1_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRSEQ-2 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->rseq_2_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->rseq_2_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nASEQ GP Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->aseq_gp_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->aseq_gp_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nASEQ-0 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->aseq_0_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->aseq_0_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nASEQ-1 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->aseq_1_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->aseq_1_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nASEQ-2 Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->aseq_2_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->aseq_2_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nCommand DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->cmd_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->cmd_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRequest0 Queue DMA Channel Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->req0_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->req0_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nResponse0 Queue DMA Channel Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->resp0_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->resp0_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRequest1 Queue DMA Channel Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->req1_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->req1_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXMT0 Data DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xmt0_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xmt0_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXMT1 Data DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xmt1_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xmt1_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXMT2 Data DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xmt2_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xmt2_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXMT3 Data DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xmt3_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xmt3_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXMT4 Data DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xmt4_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xmt4_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nXMT Data DMA Common Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->xmt_data_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->xmt_data_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRCV Thread 0 Data DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->rcvt0_data_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->rcvt0_data_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRCV Thread 1 Data DMA Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->rcvt1_data_dma_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->rcvt1_data_dma_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nRISC GP Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->risc_gp_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->risc_gp_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nLMC Registers");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->lmc_reg) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->lmc_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nFPM Hardware Registers");
+	bp += strlen(bp);
+	cnt1 = sizeof (fw->fpm_hdw_reg);
+	for (cnt = 0; cnt < cnt1 / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->fpm_hdw_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nFB Hardware Registers");
+	bp += strlen(bp);
+	cnt1 = sizeof (fw->fb_hdw_reg);
+	for (cnt = 0; cnt < cnt1 / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp++, "\n");
+		}
+		(void) sprintf(bp, "%08x ", fw->fb_hdw_reg[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nCode RAM");
+	bp += strlen(bp);
+	for (cnt = 0; cnt < sizeof (fw->code_ram) / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp, "\n%08x: ", cnt + 0x20000);
+			bp += 11;
+		}
+		(void) sprintf(bp, "%08x ", fw->code_ram[cnt]);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n\nExternal Memory");
+	bp += strlen(bp);
+	dp = (uint32_t *)((caddr_t)fw->req_rsp_ext_mem + fw->req_q_size[0] +
+	    fw->req_q_size[1] + fw->rsp_q_size + (ha->rsp_queues_cnt * 16));
+	for (cnt = 0; cnt < ha->fw_ext_memory_size / 4; cnt++) {
+		if (cnt % 8 == 0) {
+			(void) sprintf(bp, "\n%08x: ", cnt + 0x100000);
+			bp += 11;
+		}
+		(void) sprintf(bp, "%08x ", *dp++);
+		bp += 9;
+	}
+
+	(void) sprintf(bp, "\n[<==END] ISP Debug Dump");
+	bp += strlen(bp);
+
+	dp = fw->req_rsp_ext_mem + (ha->rsp_queues_cnt * 4);
+	for (cnt = 0; cnt < 2 && fw->req_q_size[cnt]; cnt++) {
+		dp2 = dp;
+		for (cnt1 = 0; cnt1 < fw->req_q_size[cnt] / 4; cnt1++) {
+			if (*dp2++) {
+				break;
+			}
+		}
+		if (cnt1 == fw->req_q_size[cnt] / 4) {
+			dp = dp2;
+			continue;
+		}
+		(void) sprintf(bp, "\n\nRequest Queue\nQueue %d:", cnt);
+		bp += strlen(bp);
+		for (cnt1 = 0; cnt1 < fw->req_q_size[cnt] / 4; cnt1++) {
+			if (cnt1 % 8 == 0) {
+				(void) sprintf(bp, "\n%08x: ", cnt1);
+				bp += strlen(bp);
+			}
+			(void) sprintf(bp, "%08x ", *dp++);
 			bp += strlen(bp);
 		}
-		(void) sprintf(bp, "%08x ", fw->rsp_q[cnt]);
+	}
+
+	for (cnt = 0; cnt < ha->rsp_queues_cnt && cnt < 16; cnt++) {
+		dp2 = dp;
+		for (cnt1 = 0; cnt1 < ha->rsp_queues[cnt]->rsp_ring.size / 4;
+		    cnt1++) {
+			if (*dp2++) {
+				break;
+			}
+		}
+		if (cnt1 == ha->rsp_queues[cnt]->rsp_ring.size / 4) {
+			dp = dp2;
+			continue;
+		}
+		(void) sprintf(bp, "\n\nResponse Queue\nQueue %d:", cnt);
 		bp += strlen(bp);
+		for (cnt1 = 0; cnt1 < ha->rsp_queues[cnt]->rsp_ring.size / 4;
+		    cnt1++) {
+			if (cnt1 % 8 == 0) {
+				(void) sprintf(bp, "\n%08x: ", cnt1);
+				bp += strlen(bp);
+			}
+			(void) sprintf(bp, "%08x ", *dp++);
+			bp += strlen(bp);
+		}
 	}
 
 	if (CFG_IST(ha, CFG_ENABLE_FWEXTTRACE) &&
@@ -13135,12 +14135,55 @@
 
 	cnt = (uint32_t)((uintptr_t)bp - (uintptr_t)bufp);
 
-	QL_PRINT_3(CE_CONT, "(%d): done=%xh\n", ha->instance, cnt);
+	QL_PRINT_10(ha, "done=%xh\n", cnt);
 
 	return (cnt);
 }
 
 /*
+ * ql_8021_ascii_fw_dump
+ *	Converts ISP8021 firmware binary dump to ascii.
+ *
+ * Input:
+ *	ha = adapter state pointer.
+ *	bptr = buffer pointer.
+ *
+ * Returns:
+ *	Amount of data buffer used.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static size_t
+ql_8021_ascii_fw_dump(ql_adapter_state_t *ha, caddr_t bufp)
+{
+	uint32_t	cnt;
+	caddr_t		bp = bufp;
+	uint8_t		*fw = ha->ql_dump_ptr;
+
+	/*
+	 * 2 ascii bytes per binary byte + a space and
+	 * a newline every 16 binary bytes
+	 */
+	cnt = 0;
+	while (cnt < ha->ql_dump_size) {
+		(void) sprintf(bp, "%02x ", *fw++);
+		bp += strlen(bp);
+		if (++cnt % 16 == 0) {
+			(void) sprintf(bp, "\n");
+			bp += strlen(bp);
+		}
+	}
+	if (cnt % 16 != 0) {
+		(void) sprintf(bp, "\n");
+		bp += strlen(bp);
+	}
+	cnt = (uint32_t)((uintptr_t)bp - (uintptr_t)bufp);
+	QL_PRINT_10(ha, "done=%xh\n", cnt);
+	return (cnt);
+}
+
+/*
  * ql_2200_binary_fw_dump
  *
  * Input:
@@ -13163,13 +14206,10 @@
 	mbx_cmd_t	*mcp = &mc;
 	int		rval = QL_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Disable ISP interrupts. */
-	WRT16_IO_REG(ha, ictrl, 0);
-	ADAPTER_STATE_LOCK(ha);
-	ha->flags &= ~INTERRUPTS_ENABLED;
-	ADAPTER_STATE_UNLOCK(ha);
+	ql_disable_intr(ha);
 
 	/* Release mailbox registers. */
 	WRT16_IO_REG(ha, semaphore, 0);
@@ -13272,7 +14312,7 @@
 
 		/* Wait for RISC to recover from reset. */
 		timer = 30000;
-		while (RD16_IO_REG(ha, mailbox_out[0]) == MBS_BUSY) {
+		while (RD16_IO_REG(ha, mailbox_out[0]) == MBS_ROM_BUSY) {
 			if (timer-- != 0) {
 				drv_usecwait(MILLISEC);
 			} else {
@@ -13346,7 +14386,7 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -13370,13 +14410,10 @@
 	clock_t	timer;
 	int	rval = QL_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Disable ISP interrupts. */
-	WRT16_IO_REG(ha, ictrl, 0);
-	ADAPTER_STATE_LOCK(ha);
-	ha->flags &= ~INTERRUPTS_ENABLED;
-	ADAPTER_STATE_UNLOCK(ha);
+	ql_disable_intr(ha);
 
 	/* Release mailbox registers. */
 	WRT16_IO_REG(ha, semaphore, 0);
@@ -13485,7 +14522,7 @@
 
 		/* Wait for RISC to recover from reset. */
 		timer = 30000;
-		while (RD16_IO_REG(ha, mailbox_out[0]) == MBS_BUSY) {
+		while (RD16_IO_REG(ha, mailbox_out[0]) == MBS_ROM_BUSY) {
 			if (timer-- != 0) {
 				drv_usecwait(MILLISEC);
 			} else {
@@ -13511,7 +14548,7 @@
 		rval = ql_read_risc_ram(ha, 0x10800, 0xf800, fw->data_ram);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -13537,7 +14574,7 @@
 	clock_t		timer;
 	int		rval = QL_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	fw->hccr = RD32_IO_REG(ha, hccr);
 
@@ -13544,7 +14581,7 @@
 	/* Pause RISC. */
 	if ((RD32_IO_REG(ha, risc2host) & RH_RISC_PAUSED) == 0) {
 		/* Disable ISP interrupts. */
-		WRT16_IO_REG(ha, ictrl, 0);
+		ql_disable_intr(ha);
 
 		WRT32_IO_REG(ha, hccr, HC24_PAUSE_RISC);
 		for (timer = 30000;
@@ -13564,11 +14601,7 @@
 		    sizeof (fw->host_reg) / 4, 32);
 
 		/* Disable ISP interrupts. */
-		WRT32_IO_REG(ha, ictrl, 0);
-		RD32_IO_REG(ha, ictrl);
-		ADAPTER_STATE_LOCK(ha);
-		ha->flags &= ~INTERRUPTS_ENABLED;
-		ADAPTER_STATE_UNLOCK(ha);
+		ql_disable_intr(ha);
 
 		/* Shadow registers. */
 
@@ -13865,12 +14898,11 @@
 	/* Get the request queue */
 	if (rval == QL_SUCCESS) {
 		uint32_t	cnt;
-		uint32_t	*w32 = (uint32_t *)ha->request_ring_bp;
+		uint32_t	*w32 = (uint32_t *)ha->req_q[0]->req_ring.bp;
 
 		/* Sync DMA buffer. */
-		(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-		    REQUEST_Q_BUFFER_OFFSET, sizeof (fw->req_q),
-		    DDI_DMA_SYNC_FORKERNEL);
+		(void) ddi_dma_sync(ha->req_q[0]->req_ring.dma_handle,
+		    0, sizeof (fw->req_q), DDI_DMA_SYNC_FORKERNEL);
 
 		for (cnt = 0; cnt < sizeof (fw->req_q) / 4; cnt++) {
 			fw->req_q[cnt] = *w32++;
@@ -13881,12 +14913,12 @@
 	/* Get the response queue */
 	if (rval == QL_SUCCESS) {
 		uint32_t	cnt;
-		uint32_t	*w32 = (uint32_t *)ha->response_ring_bp;
+		uint32_t	*w32 =
+		    (uint32_t *)ha->rsp_queues[0]->rsp_ring.bp;
 
 		/* Sync DMA buffer. */
-		(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-		    RESPONSE_Q_BUFFER_OFFSET, sizeof (fw->rsp_q),
-		    DDI_DMA_SYNC_FORKERNEL);
+		(void) ddi_dma_sync(ha->rsp_queues[0]->rsp_ring.dma_handle,
+		    0, sizeof (fw->rsp_q), DDI_DMA_SYNC_FORKERNEL);
 
 		for (cnt = 0; cnt < sizeof (fw->rsp_q) / 4; cnt++) {
 			fw->rsp_q[cnt] = *w32++;
@@ -13947,7 +14979,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -13969,19 +15001,27 @@
 static int
 ql_25xx_binary_fw_dump(ql_adapter_state_t *ha, ql_25xx_fw_dump_t *fw)
 {
-	uint32_t	*reg32;
+	uint32_t	*reg32,	cnt, *w32ptr, index, *dp;
 	void		*bp;
 	clock_t		timer;
 	int		rval = QL_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
+	fw->req_q_size[0] = ha->req_q[0]->req_ring.size;
+	if (ha->req_q[1] != NULL) {
+		fw->req_q_size[1] = ha->req_q[1]->req_ring.size;
+	}
+	fw->rsp_q_size = ha->rsp_queues[0]->rsp_ring.size * ha->rsp_queues_cnt;
+
+	fw->hccr = RD32_IO_REG(ha, hccr);
 	fw->r2h_status = RD32_IO_REG(ha, risc2host);
+	fw->aer_ues = ql_pci_config_get32(ha, 0x104);
 
 	/* Pause RISC. */
 	if ((RD32_IO_REG(ha, risc2host) & RH_RISC_PAUSED) == 0) {
 		/* Disable ISP interrupts. */
-		WRT16_IO_REG(ha, ictrl, 0);
+		ql_disable_intr(ha);
 
 		WRT32_IO_REG(ha, hccr, HC24_PAUSE_RISC);
 		for (timer = 30000;
@@ -14008,7 +15048,7 @@
 		bp = ql_read_regs(ha, fw->hostrisc_reg, ha->iobase + 0xC0,
 		    16, 32);
 		WRT32_IO_REG(ha, io_base_addr, 0x7010);
-		bp = ql_read_regs(ha, bp, ha->iobase + 0xC0, 16, 32);
+		(void) ql_read_regs(ha, bp, ha->iobase + 0xC0, 16, 32);
 
 		/* PCIe registers. */
 		WRT32_IO_REG(ha, io_base_addr, 0x7c00);
@@ -14023,13 +15063,8 @@
 		    sizeof (fw->host_reg) / 4, 32);
 
 		/* Disable ISP interrupts. */
+		ql_disable_intr(ha);
 
-		WRT32_IO_REG(ha, ictrl, 0);
-		RD32_IO_REG(ha, ictrl);
-		ADAPTER_STATE_LOCK(ha);
-		ha->flags &= ~INTERRUPTS_ENABLED;
-		ADAPTER_STATE_UNLOCK(ha);
-
 		/* Shadow registers. */
 
 		WRT32_IO_REG(ha, io_base_addr, 0x0F70);
@@ -14397,44 +15432,87 @@
 		(void) ql_read_regs(ha, bp, ha->iobase + 0xC0, 16, 32);
 	}
 
-	/* Get the request queue */
 	if (rval == QL_SUCCESS) {
-		uint32_t	cnt;
-		uint32_t	*w32 = (uint32_t *)ha->request_ring_bp;
-
-		/* Sync DMA buffer. */
-		(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-		    REQUEST_Q_BUFFER_OFFSET, sizeof (fw->req_q),
-		    DDI_DMA_SYNC_FORKERNEL);
-
-		for (cnt = 0; cnt < sizeof (fw->req_q) / 4; cnt++) {
-			fw->req_q[cnt] = *w32++;
-			LITTLE_ENDIAN_32(&fw->req_q[cnt]);
+		/* Get the Queue Pointers */
+		dp = fw->req_rsp_ext_mem;
+		for (index = 0; index < ha->rsp_queues_cnt; index++) {
+			if (index == 0 && ha->flags & MULTI_QUEUE) {
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[0]->mbar_req_in);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[0]->mbar_req_out);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			} else if (index == 1 && ha->flags & MULTI_QUEUE) {
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[1]->mbar_req_in);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[1]->mbar_req_out);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			} else {
+				*dp++ = 0;
+				*dp++ = 0;
+			}
+			if (ha->flags & MULTI_QUEUE) {
+				*dp = RD32_MBAR_REG(ha,
+				    ha->rsp_queues[index]->mbar_rsp_in);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+				*dp = RD32_MBAR_REG(ha,
+				    ha->rsp_queues[index]->mbar_rsp_out);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			} else {
+				*dp++ = 0;
+				*dp++ = 0;
+			}
 		}
-	}
+		/* Get the request queue */
+		(void) ddi_dma_sync(ha->req_q[0]->req_ring.dma_handle, 0, 0,
+		    DDI_DMA_SYNC_FORCPU);
+		w32ptr = (uint32_t *)ha->req_q[0]->req_ring.bp;
+		for (cnt = 0; cnt < fw->req_q_size[0] / 4; cnt++) {
+			*dp = *w32ptr++;
+			LITTLE_ENDIAN_32(dp);
+			dp++;
+		}
+		if (ha->req_q[1] != NULL) {
+			(void) ddi_dma_sync(ha->req_q[1]->req_ring.dma_handle,
+			    0, 0, DDI_DMA_SYNC_FORCPU);
+			w32ptr = (uint32_t *)ha->req_q[1]->req_ring.bp;
+			for (cnt = 0; cnt < fw->req_q_size[1] / 4; cnt++) {
+				*dp = *w32ptr++;
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			}
+		}
 
-	/* Get the respons queue */
-	if (rval == QL_SUCCESS) {
-		uint32_t	cnt;
-		uint32_t	*w32 = (uint32_t *)ha->response_ring_bp;
-
-		/* Sync DMA buffer. */
-		(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-		    RESPONSE_Q_BUFFER_OFFSET, sizeof (fw->rsp_q),
-		    DDI_DMA_SYNC_FORKERNEL);
-
-		for (cnt = 0; cnt < sizeof (fw->rsp_q) / 4; cnt++) {
-			fw->rsp_q[cnt] = *w32++;
-			LITTLE_ENDIAN_32(&fw->rsp_q[cnt]);
+		/* Get the response queues */
+		for (index = 0; index < ha->rsp_queues_cnt; index++) {
+			(void) ddi_dma_sync(
+			    ha->rsp_queues[index]->rsp_ring.dma_handle,
+			    0, 0, DDI_DMA_SYNC_FORCPU);
+			w32ptr = (uint32_t *)
+			    ha->rsp_queues[index]->rsp_ring.bp;
+			for (cnt = 0;
+			    cnt < ha->rsp_queues[index]->rsp_ring.size / 4;
+			    cnt++) {
+				*dp = *w32ptr++;
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			}
 		}
 	}
 
 	/* Reset RISC. */
-
 	ql_reset_chip(ha);
 
 	/* Memory. */
-
 	if (rval == QL_SUCCESS) {
 		/* Code RAM. */
 		rval = ql_read_risc_ram(ha, 0x20000,
@@ -14443,7 +15521,7 @@
 	if (rval == QL_SUCCESS) {
 		/* External Memory. */
 		rval = ql_read_risc_ram(ha, 0x100000,
-		    ha->fw_ext_memory_size / 4, fw->ext_mem);
+		    ha->fw_ext_memory_size / 4, dp);
 	}
 
 	/* Get the FC event trace buffer */
@@ -14484,7 +15562,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -14506,19 +15584,27 @@
 static int
 ql_81xx_binary_fw_dump(ql_adapter_state_t *ha, ql_81xx_fw_dump_t *fw)
 {
-	uint32_t	*reg32;
+	uint32_t	*reg32, cnt, *w32ptr, index, *dp;
 	void		*bp;
 	clock_t		timer;
 	int		rval = QL_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
+	fw->req_q_size[0] = ha->req_q[0]->req_ring.size;
+	if (ha->req_q[1] != NULL) {
+		fw->req_q_size[1] = ha->req_q[1]->req_ring.size;
+	}
+	fw->rsp_q_size = ha->rsp_queues[0]->rsp_ring.size * ha->rsp_queues_cnt;
+
+	fw->hccr = RD32_IO_REG(ha, hccr);
 	fw->r2h_status = RD32_IO_REG(ha, risc2host);
+	fw->aer_ues = ql_pci_config_get32(ha, 0x104);
 
 	/* Pause RISC. */
 	if ((RD32_IO_REG(ha, risc2host) & RH_RISC_PAUSED) == 0) {
 		/* Disable ISP interrupts. */
-		WRT16_IO_REG(ha, ictrl, 0);
+		ql_disable_intr(ha);
 
 		WRT32_IO_REG(ha, hccr, HC24_PAUSE_RISC);
 		for (timer = 30000;
@@ -14545,7 +15631,7 @@
 		bp = ql_read_regs(ha, fw->hostrisc_reg, ha->iobase + 0xC0,
 		    16, 32);
 		WRT32_IO_REG(ha, io_base_addr, 0x7010);
-		bp = ql_read_regs(ha, bp, ha->iobase + 0xC0, 16, 32);
+		(void) ql_read_regs(ha, bp, ha->iobase + 0xC0, 16, 32);
 
 		/* PCIe registers. */
 		WRT32_IO_REG(ha, io_base_addr, 0x7c00);
@@ -14560,13 +15646,8 @@
 		    sizeof (fw->host_reg) / 4, 32);
 
 		/* Disable ISP interrupts. */
+		ql_disable_intr(ha);
 
-		WRT32_IO_REG(ha, ictrl, 0);
-		RD32_IO_REG(ha, ictrl);
-		ADAPTER_STATE_LOCK(ha);
-		ha->flags &= ~INTERRUPTS_ENABLED;
-		ADAPTER_STATE_UNLOCK(ha);
-
 		/* Shadow registers. */
 
 		WRT32_IO_REG(ha, io_base_addr, 0x0F70);
@@ -14940,44 +16021,87 @@
 		(void) ql_read_regs(ha, bp, ha->iobase + 0xC0, 16, 32);
 	}
 
-	/* Get the request queue */
 	if (rval == QL_SUCCESS) {
-		uint32_t	cnt;
-		uint32_t	*w32 = (uint32_t *)ha->request_ring_bp;
-
-		/* Sync DMA buffer. */
-		(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-		    REQUEST_Q_BUFFER_OFFSET, sizeof (fw->req_q),
-		    DDI_DMA_SYNC_FORKERNEL);
-
-		for (cnt = 0; cnt < sizeof (fw->req_q) / 4; cnt++) {
-			fw->req_q[cnt] = *w32++;
-			LITTLE_ENDIAN_32(&fw->req_q[cnt]);
+		/* Get the Queue Pointers */
+		dp = fw->req_rsp_ext_mem;
+		for (index = 0; index < ha->rsp_queues_cnt; index++) {
+			if (index == 0 && ha->flags & MULTI_QUEUE) {
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[0]->mbar_req_in);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[0]->mbar_req_out);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			} else if (index == 1 && ha->flags & MULTI_QUEUE) {
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[1]->mbar_req_in);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+				*dp = RD32_MBAR_REG(ha,
+				    ha->req_q[1]->mbar_req_out);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			} else {
+				*dp++ = 0;
+				*dp++ = 0;
+			}
+			if (ha->flags & MULTI_QUEUE) {
+				*dp = RD32_MBAR_REG(ha,
+				    ha->rsp_queues[index]->mbar_rsp_in);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+				*dp = RD32_MBAR_REG(ha,
+				    ha->rsp_queues[index]->mbar_rsp_out);
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			} else {
+				*dp++ = 0;
+				*dp++ = 0;
+			}
 		}
-	}
+		/* Get the request queue */
+		(void) ddi_dma_sync(ha->req_q[0]->req_ring.dma_handle, 0, 0,
+		    DDI_DMA_SYNC_FORCPU);
+		w32ptr = (uint32_t *)ha->req_q[0]->req_ring.bp;
+		for (cnt = 0; cnt < fw->req_q_size[0] / 4; cnt++) {
+			*dp = *w32ptr++;
+			LITTLE_ENDIAN_32(dp);
+			dp++;
+		}
+		if (ha->req_q[1] != NULL) {
+			(void) ddi_dma_sync(ha->req_q[1]->req_ring.dma_handle,
+			    0, 0, DDI_DMA_SYNC_FORCPU);
+			w32ptr = (uint32_t *)ha->req_q[1]->req_ring.bp;
+			for (cnt = 0; cnt < fw->req_q_size[1] / 4; cnt++) {
+				*dp = *w32ptr++;
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			}
+		}
 
-	/* Get the response queue */
-	if (rval == QL_SUCCESS) {
-		uint32_t	cnt;
-		uint32_t	*w32 = (uint32_t *)ha->response_ring_bp;
-
-		/* Sync DMA buffer. */
-		(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-		    RESPONSE_Q_BUFFER_OFFSET, sizeof (fw->rsp_q),
-		    DDI_DMA_SYNC_FORKERNEL);
-
-		for (cnt = 0; cnt < sizeof (fw->rsp_q) / 4; cnt++) {
-			fw->rsp_q[cnt] = *w32++;
-			LITTLE_ENDIAN_32(&fw->rsp_q[cnt]);
+		/* Get the response queues */
+		for (index = 0; index < ha->rsp_queues_cnt; index++) {
+			(void) ddi_dma_sync(
+			    ha->rsp_queues[index]->rsp_ring.dma_handle,
+			    0, 0, DDI_DMA_SYNC_FORCPU);
+			w32ptr = (uint32_t *)
+			    ha->rsp_queues[index]->rsp_ring.bp;
+			for (cnt = 0;
+			    cnt < ha->rsp_queues[index]->rsp_ring.size / 4;
+			    cnt++) {
+				*dp = *w32ptr++;
+				LITTLE_ENDIAN_32(dp);
+				dp++;
+			}
 		}
 	}
 
 	/* Reset RISC. */
-
 	ql_reset_chip(ha);
 
 	/* Memory. */
-
 	if (rval == QL_SUCCESS) {
 		/* Code RAM. */
 		rval = ql_read_risc_ram(ha, 0x20000,
@@ -14986,7 +16110,7 @@
 	if (rval == QL_SUCCESS) {
 		/* External Memory. */
 		rval = ql_read_risc_ram(ha, 0x100000,
-		    ha->fw_ext_memory_size / 4, fw->ext_mem);
+		    ha->fw_ext_memory_size / 4, dp);
 	}
 
 	/* Get the FC event trace buffer */
@@ -15027,7 +16151,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -15065,9 +16189,9 @@
 		WRT16_IO_REG(ha, mailbox_in[0], MBC_READ_RAM_EXTENDED);
 		WRT16_IO_REG(ha, mailbox_in[1], LSW(risc_address));
 		WRT16_IO_REG(ha, mailbox_in[8], MSW(risc_address));
-		if (CFG_IST(ha, CFG_CTRL_8021)) {
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
 			WRT32_IO_REG(ha, nx_host_int, NX_MBX_CMD);
-		} else if (CFG_IST(ha, CFG_CTRL_242581)) {
+		} else if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			WRT32_IO_REG(ha, hccr, HC24_SET_HOST_INT);
 		} else {
 			WRT16_IO_REG(ha, hccr, HC_SET_HOST_INT);
@@ -15077,7 +16201,7 @@
 				stat = (uint16_t)
 				    (RD16_IO_REG(ha, risc2host) & 0xff);
 				if ((stat == 1) || (stat == 0x10)) {
-					if (CFG_IST(ha, CFG_CTRL_24258081)) {
+					if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 						buf32[cnt] = SHORT_TO_LONG(
 						    RD16_IO_REG(ha,
 						    mailbox_out[2]),
